/*
   Dico

   Luc Maranget, projet Moscova, Inria Rocquencourt
 
   Copyright 2005 Institut National de Recherche en Informatique et    
   en Automatique.  All rights reserved.  This file is distributed     
   under the terms of the Q Public License version 1.0.                
*/

class Words {
  final static int SIZE=16 ;
  private String t[] ;
  private int sp ;
  private int minLen ;
  private int below ;
  private Code c ;

  int below() {
    return below ;
  }
    
  Words (int minLen, int below, Code c) {
    t = new String[SIZE] ;
    sp = 0 ;
    this.minLen = minLen ;
    this.below = below ;
    this.c = c ;
  }

  private void realloc() {
    String [] newT = new String [2*t.length] ;

    for (int i = 0 ; i < t.length ; i++)
      newT[i] = t[i] ;
    t = newT ;
  }

  private void push(String s) {
    if (sp >= t.length)
      realloc() ;
    t[sp++] = s ;
  }

  String push(StringBuffer b) {
    String s = b.toString () ;
    int len = s.length() ;
    if (len >= minLen ||  below > 0) {
      if (len < minLen) --below ;
      b.setLength(0) ;
      push(s) ;
      return s ;
    } else {
      return null ;
    }
  }


  private String pop() {
    if (sp <= 0) {
      System.err.println("Empty stack") ;
      System.exit(2) ;
      return null ;
    } else {
      return t[--sp] ;
    }
  }

  void pop(StringBuffer b) {
    String s = pop() ;

    if (s.length() < minLen) ++below ;
    b.setLength(0) ;
    b.append(s) ;    
  }

  int length() {
    return sp ;
  }

  public String toString() {
    StringBuffer b = new StringBuffer () ;

    if (sp > 0) {
      b.append(c.decode(t[0])) ;
      for (int i = 1 ; i < sp ; i++)
        b.append(" " + c.decode(t[i])) ;
    }
    return b.toString() ;
  }
}
